SystemOrganization addCategory: #SWA014!

Object subclass: #SWA014Random
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Random class methodsFor: 'chances' stamp: 'TZ 2/2/2017 18:11'!
isTrueIn: aNumber outOf: aNumberOfCases
	
	^ (Random new nextInt: aNumberOfCases) <= aNumber.! !

CircleMorph subclass: #SWA014LivingThing
	instanceVariableNames: 'bodysize speed speedSaver id direction currentStep maxAllowedSize minAllowedSize minAllowedSpeed maxAllowedSpeed realCenter upgradeList game swaworld'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014LivingThing commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Ein sich aktiv bewegendes am Spiel teilnehmendes Object.!

SWA014LivingThing subclass: #SWA014Enemy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Enemy commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Ein Konkurrent im Spiel.!

!SWA014Enemy methodsFor: 'movement' stamp: 'TZ 2/2/2017 20:29'!
calculateDirection: target
	"Enemys should follow the nearest object, which could be eaten by them. Also they should run away, if there is a bigger LivingThing (Player or Enemy) nearby."
	|direction|
	
	direction := super calculateDirection: target realCenter.
	^ self < target
		ifTrue: [direction negated]
		ifFalse: [direction].
	! !

!SWA014Enemy methodsFor: 'collision handling' stamp: 'TZ 2/2/2017 19:47'!
getEaten
	
	self game spawnEnemy.
	self delete.
	! !

!SWA014Enemy methodsFor: 'override' stamp: 'TZ 2/2/2017 20:29'!
step

	self 
		direction: (self calculateDirection: self nearestLivingThing);
		moveAutomatically;
		yourself. 
	
	self upgradeList do: [:aUpgrade| aUpgrade activateIfNotCooling].
	
	super step.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'TZ 2/2/2017 19:09'!
< aLivingThing

	^ self bodysize < aLivingThing bodysize.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'TZ 2/2/2017 19:09'!
> aLivingThing

	^ self bodysize > aLivingThing bodysize.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'TZ 2/2/2017 19:09'!
addMassOf: aLivingThing

	self bodysize: 2 * ((self squaredRadius + aLivingThing squaredRadius) sqrt).! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'TZ 2/2/2017 19:50'!
bigNumber

	^ SmallInteger maxVal.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'TZ 2/2/2017 19:09'!
bodysize

	^ bodysize.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'TZ 2/2/2017 19:16'!
bodysize: aSize
	
	bodysize := {self maxAllowedSize. {self minAllowedSize. aSize} max} min.
! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'TZ 2/2/2017 19:17'!
calculateDirection: target

	^ self vectorToPoint: target.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'TZ 2/2/2017 19:52'!
calculateRealCenterFor: aPosition
	"Converts a absolute position to a relative position like realCenter"
	self flag: 'TODISCUSS: In welche Klasse gehört diese Methode?'.
	
	^ aPosition - self swaworld realCenter + self swaworld radius asPoint.! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'TZ 2/2/2017 19:19'!
checkForCollisions

	self checkForCollisionsWithLivingThings.! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'TZ 2/2/2017 19:32'!
checkForCollisionsWithLivingThings

	self swaworld listOfLivingThings do: [:aLivingThing|
		(self checkForOverlapWith: aLivingThing) ifTrue: [
			aLivingThing < self 
				ifTrue: [
					aLivingThing goBehind.
					(self squaredDistanceTo: aLivingThing realCenter) < self squaredRadius ifTrue: [
						self eat: aLivingThing]]
				ifFalse: [aLivingThing comeToFront].
			self swaworld image goBehind]] without: self.! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'TZ 2/2/2017 19:29'!
checkForOverlapWith: enemy

	^ self bottom > enemy top and: 
	    self top < enemy bottom and:
	    self left < enemy right and:
	    self right > enemy left.
! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'TZ 2/2/2017 19:31'!
direction

	^ direction.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'TZ 2/2/2017 19:32'!
direction: aDirection

	direction := aDirection.! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'TZ 2/2/2017 20:32'!
eat: prey

	self addMassOf: prey.
	self swaworld listOfEnemies remove: prey ifAbsent: [].
	
	prey getEaten.
	
	self isPlayerBlob ifTrue: [self checkForEvolution.].! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'TZ 1/27/2017 18:22'!
game
	
	^ game.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'TZ 1/27/2017 18:22'!
game: aGame

	game := aGame.! !

!SWA014LivingThing methodsFor: 'collision handling' stamp: 'TZ 2/2/2017 19:46'!
getEaten
	
	self delete.! !

!SWA014LivingThing methodsFor: 'initialization' stamp: 'TZ 2/2/2017 19:51'!
initialize
	super initialize.
	
	self 
		maxAllowedSize: 800;
		maxAllowedSpeed: 100;
		minAllowedSize: 10;
		minAllowedSpeed: 0;
		speed: 2.0;
		speedSaver: 2.0;
		direction: 0.0 asPoint;
		borderWidth: 2; "these initial values don't change at runtime"
		upgradeList: Dictionary new;
		yourself.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'TZ 2/2/2017 20:32'!
isPlayerBlob

	^ false.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'TZ 2/2/2017 19:50'!
maxAllowedSize

	^ maxAllowedSize.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'TZ 2/2/2017 19:50'!
maxAllowedSize: aNumber

	maxAllowedSize := aNumber.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'TZ 2/2/2017 19:51'!
maxAllowedSpeed

	^ maxAllowedSpeed.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'TZ 2/2/2017 19:51'!
maxAllowedSpeed: aNumber

	maxAllowedSpeed := aNumber.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'TZ 2/2/2017 19:51'!
minAllowedSize

	^ minAllowedSize.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'TZ 2/2/2017 19:51'!
minAllowedSize: aNumber

	minAllowedSize := aNumber.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'TZ 2/2/2017 19:51'!
minAllowedSpeed

	^ minAllowedSpeed.! !

!SWA014LivingThing methodsFor: 'constants' stamp: 'TZ 2/2/2017 19:51'!
minAllowedSpeed: aNumber

	minAllowedSpeed := aNumber.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'TZ 2/2/2017 19:52'!
moveAutomatically

	self realCenter: self realCenter + (self speed * self direction).
	self refreshCenter.! !

!SWA014LivingThing methodsFor: 'vision' stamp: 'TZ 2/2/2017 20:25'!
nearestLivingThing
	|nearestEnemyobject smallestDistance currentDistance |

	smallestDistance := self bigNumber.
	nearestEnemyobject := self.
		
	self swaworld listOfLivingThings do: [:livingThing| 
		currentDistance := self squaredDistanceTo: (livingThing realCenter).
		currentDistance  < smallestDistance ifTrue: [
			smallestDistance := currentDistance.
			nearestEnemyobject := livingThing]]
	without: self.

	^ nearestEnemyobject.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'TZ 2/2/2017 19:43'!
radius

	^ self bodysize / 2.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'TZ 2/2/2017 19:42'!
realCenter

	^ realCenter.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'TZ 2/2/2017 19:42'!
realCenter: aPoint

	realCenter := aPoint.! !

!SWA014LivingThing methodsFor: 'upgrade management' stamp: 'TZ 1/27/2017 19:23'!
receiveUpgrade: anUpgrade

	self addMorph: anUpgrade.
	anUpgrade hide.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'TZ 2/2/2017 19:53'!
refreshCenter

	self center: self swaworld realCenter - (self swaworld extent / 2) + self realCenter.! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'TZ 2/2/2017 19:44'!
refreshSize

	self extent: self bodysize asPoint.
	
	! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'TZ 2/2/2017 19:53'!
saveSpeed

	self speedSaver: self speed.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'TZ 2/2/2017 19:53'!
speed

	^ speed.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'TZ 2/2/2017 19:54'!
speed: aSpeed

	speed := {minAllowedSpeed. {maxAllowedSpeed. aSpeed} min} max.
! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'TZ 2/2/2017 19:55'!
speedSaver

	^ speedSaver.! !

!SWA014LivingThing methodsFor: 'movement' stamp: 'TZ 2/2/2017 19:55'!
speedSaver: aSpeed

	speedSaver := aSpeed.! !

!SWA014LivingThing methodsFor: 'vision' stamp: 'TZ 2/2/2017 19:33'!
squaredDistanceTo: enemy
	"Pythagoras' theorem without sqrt"
	
	^ (enemy x - self realCenter x) squared + (enemy y - self realCenter y) squared. ! !

!SWA014LivingThing methodsFor: 'body transformation' stamp: 'TZ 2/2/2017 19:34'!
squaredRadius
	"Der Radius wird Quadriert, damit wir, wenn wir mit ihm vergleichen, keine Wurzel ziehen müssen (Phytagoras)"
	
	^ self radius squared. ! !

!SWA014LivingThing methodsFor: 'override' stamp: 'TZ 2/2/2017 19:35'!
step

	self
		checkForCollisions;
		refreshSize;
		yourself.! !

!SWA014LivingThing methodsFor: 'override' stamp: 'TZ 2/2/2017 19:56'!
stepTime

	^ 10.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'TZ 2/2/2017 19:42'!
swaworld

	^ swaworld.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'TZ 2/2/2017 19:43'!
swaworld: aWorld
	
	swaworld := aWorld.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'TZ 2/2/2017 19:43'!
upgradeList

	^ upgradeList.! !

!SWA014LivingThing methodsFor: 'accessing' stamp: 'TZ 2/2/2017 19:43'!
upgradeList: aList

	upgradeList := aList.! !

!SWA014LivingThing methodsFor: 'vision' stamp: 'TZ 2/2/2017 20:26'!
vectorToPoint: aPoint
	
	^ (aPoint - self realCenter) normalized.! !

SWA014LivingThing subclass: #SWA014PlayerBlob
	instanceVariableNames: 'level'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014PlayerBlob commentStamp: 'M.V. 11/11/2016 11:50' prior: 0!
Der Spieler.!

!SWA014PlayerBlob methodsFor: 'body transformation' stamp: 'TZ 2/2/2017 19:01'!
checkForEvolution

	self bodysize > self evolutionSize ifTrue: [self evolve].! !

!SWA014PlayerBlob methodsFor: 'constants' stamp: 'TZ 2/2/2017 19:01'!
evolutionSize
	
	^ 700.! !

!SWA014PlayerBlob methodsFor: 'body transformation' stamp: 'TZ 2/2/2017 20:31'!
evolve

	self game showEvolveOptions.
	
	self
		bodysize: 50;
		level: self level + 1;
		yourself.
	! !

!SWA014PlayerBlob methodsFor: 'collision handling' stamp: 'TZ 2/2/2017 19:48'!
getEaten

	self game gameOver.! !

!SWA014PlayerBlob methodsFor: 'initialization' stamp: 'TZ 2/2/2017 19:03'!
initialize
	super initialize.
	
	self
		speed: 3;
		level: 0;
		yourself.! !

!SWA014PlayerBlob methodsFor: 'constants' stamp: 'TZ 2/2/2017 20:32'!
isPlayerBlob

 	^ true.! !

!SWA014PlayerBlob methodsFor: 'accessing' stamp: 'TZ 2/2/2017 18:59'!
level

	^ level.! !

!SWA014PlayerBlob methodsFor: 'accessing' stamp: 'TZ 2/2/2017 18:59'!
level: aNumber

	level := aNumber.! !

!SWA014PlayerBlob methodsFor: 'movement' stamp: 'TZ 2/2/2017 19:05'!
moveAutomatically

	self swaworld
		realCenter: self swaworld realCenter - (self speed * self direction);
		refreshCenter;
		yourself.
		
	self
		realCenter: self realCenter + (self speed * self direction);
		refreshCenter;
		yourself.! !

!SWA014PlayerBlob methodsFor: 'upgrade management' stamp: 'TZ 1/27/2017 18:21'!
receiveUpgrade: anUpgrade

	self game upgradeBar add: anUpgrade.! !

!SWA014PlayerBlob methodsFor: 'override' stamp: 'MV 1/21/2017 15:30'!
step
	super step.
	
	self 
		direction: (self calculateDirection: (self calculateRealCenterFor: World activeHand center));
		moveAutomatically;
		yourself.! !

CircleMorph subclass: #SWA014Trap
	instanceVariableNames: 'swaworld scalingFactor preySpeed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Trap methodsFor: 'constants' stamp: 'TZ 2/2/2017 20:43'!
ailmentDuration

	^ 5000.! !

!SWA014Trap methodsFor: 'collision handling' stamp: 'TZ 2/2/2017 20:41'!
checkForCollisionsWithLivingThings

	self swaworld listOfLivingThings do: [:aLivingThing|
		(aLivingThing squaredDistanceTo: (aLivingThing calculateRealCenterFor: self center)) < aLivingThing squaredRadius ifTrue: [
			self collideWith: aLivingThing]].! !

!SWA014Trap methodsFor: 'collision handling' stamp: 'TZ 2/2/2017 20:44'!
collideWith: aLivingThing

	self
		inflictAilmentTo: aLivingThing;
		futureDo: #removeAilmentOf: at: self ailmentDuration args: (Array with: aLivingThing);
		delete.! !

!SWA014Trap methodsFor: 'ailments' stamp: 'TZ 2/2/2017 20:38'!
inflictAilmentTo: aLivingThing

	aLivingThing bodysize: aLivingThing bodysize / self scalingFactor.
	aLivingThing saveSpeed.
	aLivingThing speed: 0.! !

!SWA014Trap methodsFor: 'initialization' stamp: 'TZ 2/2/2017 20:44'!
initialize
	super initialize.
	
	self 
		color: Color blue;
		extent: 15 asPoint;
		scalingFactor: 1.5;
		yourself.! !

!SWA014Trap methodsFor: 'ailments' stamp: 'TZ 2/2/2017 20:38'!
removeAilmentOf: aLivingThing

	aLivingThing speed: aLivingThing speedSaver.
	aLivingThing bodysize: aLivingThing bodysize * self scalingFactor.! !

!SWA014Trap methodsFor: 'accessing' stamp: 'TZ 2/2/2017 20:36'!
scalingFactor

	^ scalingFactor.! !

!SWA014Trap methodsFor: 'accessing' stamp: 'TZ 2/2/2017 20:36'!
scalingFactor: aFactor

	scalingFactor := aFactor.! !

!SWA014Trap methodsFor: 'override' stamp: 'TZ 2/2/2017 20:45'!
step

	self checkForCollisionsWithLivingThings.! !

!SWA014Trap methodsFor: 'override' stamp: 'TZ 2/2/2017 20:45'!
stepTime

	^ 100.! !

!SWA014Trap methodsFor: 'accessing' stamp: 'TZ 2/2/2017 20:36'!
swaworld

	^ swaworld.! !

!SWA014Trap methodsFor: 'accessing' stamp: 'TZ 2/2/2017 20:36'!
swaworld: anWorld

	swaworld := anWorld.! !

Morph subclass: #SWA014EvolveMenu
	instanceVariableNames: 'game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014EvolveMenu methodsFor: 'as yet unclassified' stamp: 'TZ 1/27/2017 18:38'!
game
	
	^ game.! !

!SWA014EvolveMenu methodsFor: 'as yet unclassified' stamp: 'TZ 1/27/2017 18:38'!
game: aGame

	game := aGame.! !

!SWA014EvolveMenu methodsFor: 'as yet unclassified' stamp: 'Tc 2/3/2017 11:25'!
initialize
	super initialize.
	
	self color: Color transparent.! !

!SWA014EvolveMenu methodsFor: 'as yet unclassified' stamp: 'TZ 1/27/2017 19:04'!
showOptions: anOptionList
	|evolveOption|
	
	1 to: (anOptionList size - 3) do: [:aNumber| anOptionList remove: anOptionList atRandom].
	
	anOptionList do: [:anOption|
		evolveOption := SWA014EvolveOption newWithUpgrade: anOption.
		evolveOption game: self game.
		evolveOption center: ((anOptionList indexOf: anOption) / (anOptionList size  + 1) * self width)@(self center y).
		self addMorph: evolveOption].
	anOptionList isEmpty ifFalse: [self game pause].! !

Morph subclass: #SWA014EvolveOption
	instanceVariableNames: 'upgrade game'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014EvolveOption class methodsFor: 'initialization' stamp: 'MV 1/20/2017 14:47'!
newWithUpgrade: anUpgrade
	^ self new
		initializeWith: anUpgrade;
		yourself.! !

!SWA014EvolveOption methodsFor: 'initialization' stamp: 'TZ 1/27/2017 16:24'!
createChooseButton
	| chooseButton |
	
	chooseButton := SWA014ChooseButton new.
	chooseButton center: (self center x)@(self height * 3 / 4).
	self addMorph: chooseButton.! !

!SWA014EvolveOption methodsFor: 'initialization' stamp: 'TZ 1/27/2017 16:25'!
createStringMorphForOption
	| stringMorph |

	stringMorph := StringMorph new.
	stringMorph acceptValue: self upgrade.	
	stringMorph center: (self center x)@(self height * 1 / 4).
	self addMorph: stringMorph.! !

!SWA014EvolveOption methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:30'!
game

	^ game.! !

!SWA014EvolveOption methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:30'!
game: aGame

	game := aGame.! !

!SWA014EvolveOption methodsFor: 'upgrade managment' stamp: 'TZ 1/27/2017 18:35'!
getChosen

	self game enable: self upgrade for: self game swaworld blob.
	self owner delete.
	self game continue.
	self game upgradesUnavailableToPlayerBlob remove: self upgrade ifAbsent: [].! !

!SWA014EvolveOption methodsFor: 'initialization' stamp: 'TZ 1/27/2017 16:29'!
initializeWith: anUpgrade
	
	self 
		extent: 150@250;
		color: Color white;
		upgrade: anUpgrade;
		createChooseButton;
		createStringMorphForOption;
		yourself.
! !

!SWA014EvolveOption methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:32'!
upgrade

	^ upgrade.! !

!SWA014EvolveOption methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:32'!
upgrade: anUpgrade

	upgrade := anUpgrade.! !

Morph subclass: #SWA014Game
	instanceVariableNames: 'upgradeDictionary upgradesUnavailableToPlayerBlob isPaused world upgradeBar aPosition'
	classVariableNames: 'Highscore'
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Game commentStamp: 'M.V. 11/11/2016 11:51' prior: 0!
Hält instanzen von World fest.!

!SWA014Game class methodsFor: 'as yet unclassified' stamp: 'MV 1/20/2017 15:20'!
highscore
	^ Highscore! !

!SWA014Game class methodsFor: 'as yet unclassified' stamp: 'MV 1/20/2017 15:20'!
highscore: aHighscore
	Highscore := aHighscore! !

!SWA014Game class methodsFor: 'as yet unclassified' stamp: 'Tc 1/27/2017 10:16'!
open
	self flag: 'TODO: Here is some code commented out: Decide what to do with it later'.
	^self new spawnPlayerBlob; openHighscoreWindow; "spawnEnemy;" "spawnFood;" openInWorld; spawnUpgradeBar; yourself.! !

!SWA014Game methodsFor: 'game events' stamp: 'TZ 1/27/2017 16:59'!
continue

	self swaworld listOfLivingThings do: [:aLivingThing| aLivingThing speed: aLivingThing speedSaver].
	self isPaused: false.! !

!SWA014Game methodsFor: 'constants' stamp: 'Tc 2/3/2017 11:26'!
defaultMaxEnemySize

	^ 100.! !

!SWA014Game methodsFor: 'upgrade managment' stamp: 'Tc 2/3/2017 12:03'!
enable: anUpgradeKey for: aLivingThing
	|anUpgrade|
	
	anUpgrade := (self upgradeDictionary at: anUpgradeKey ifAbsent: [SWA014NullUpgrade]) new.
	anUpgrade upgradeOwner: aLivingThing.
	aLivingThing receiveUpgrade: anUpgrade.
	aLivingThing upgradeList add: (anUpgradeKey->anUpgrade).
! !

!SWA014Game methodsFor: 'game events' stamp: 'TZ 1/27/2017 16:59'!
gameOver

	self delete.! !

!SWA014Game methodsFor: 'spawning' stamp: 'Tc 2/3/2017 12:05'!
giveUpgradesToEnemy: enemy
	|upgradeNumberToEnable listOfKeys|

	listOfKeys := self upgradeDictionary keys asOrderedCollection.
	upgradeNumberToEnable := {listOfKeys size. self swaworld blob level} min.
	
	1 to: upgradeNumberToEnable do: [:aNumber|
		| randomUpgradeKey |
		randomUpgradeKey := listOfKeys atRandom.
		self enable: randomUpgradeKey for: enemy.
		listOfKeys remove: randomUpgradeKey].! !

!SWA014Game methodsFor: 'input events' stamp: 'TZ 2/2/2017 17:19'!
handleKeystroke: anEvent
	|keyValue|
	
	self flag: 'TODISCUSS: Soll hier ein Dictionary benutzt werden?'.
	
	keyValue := anEvent keyValue.
	
	keyValue = 49 ifTrue: [ "Taste: 1"
		(self swaworld blob upgradeList at: #Trap ifAbsent: [SWA014NullUpgrade new]) activateIfNotCooling].
	keyValue = 50 ifTrue: [ "Taste: 2"
		(self swaworld blob upgradeList at: #Speedboost ifAbsent: [SWA014NullUpgrade new]) activateIfNotCooling].
	keyValue = 51 ifTrue: [ "Taste: 3"
		(self swaworld blob upgradeList at: #Shockwave ifAbsent: [SWA014NullUpgrade new]) activateIfNotCooling].
	keyValue = 52 ifTrue: [ "Taste: 4"
		(self swaworld blob upgradeList at: #Drain ifAbsent: [SWA014NullUpgrade new]) activateIfNotCooling].
	keyValue = 120 ifTrue: [ "Taste: x"
		self delete].	
	keyValue = 112 ifTrue: [ "Taste: p"
		self isPaused 
			ifTrue: [self continue]
			ifFalse: [self pause]].	
	
	Transcript show: keyValue.! !

!SWA014Game methodsFor: 'input events' stamp: 'TZ 2/2/2017 17:19'!
handlesMouseOver: anEvent
	
	^ true.! !

!SWA014Game methodsFor: 'initialization' stamp: 'Tc 2/3/2017 11:55'!
initialize
	super initialize.

	self flag: 'TODO: Verantwortlichkeiten auslagern, z.B. Spawner-Klasse erschaffen.'.

	self 
		extent: ActiveWorld extent;
		clipSubmorphs: true;
		
		isPaused: false;
	
		initializeWorld;
		initializeDictionary;
		initializeUpgradesUnavailableToPlayerBlob;
		
		spawnPlayerBlob;
		spawnInitialEnemies;
		spawnUpgradeBar;
		openHighscoreWindow;
		openInWorld;
		
		yourself.
		
! !

!SWA014Game methodsFor: 'initialization' stamp: 'TZ 1/27/2017 19:30'!
initializeDictionary
	
	self upgradeDictionary: (Dictionary newFrom: {
		#Trap->SWA014TrapUpgrade.
		#Speedboost->SWA014SpeedboostUpgrade.
		#Drain->SWA014DrainUpgrade.
		#Shockwave->SWA014ShockwaveUpgrade}).! !

!SWA014Game methodsFor: 'initialization' stamp: 'TZ 1/27/2017 19:32'!
initializeUpgradesUnavailableToPlayerBlob

	self upgradesUnavailableToPlayerBlob: self upgradeDictionary keys asOrderedCollection.! !

!SWA014Game methodsFor: 'initialization' stamp: 'Tc 2/3/2017 11:56'!
initializeWorld
	
	self swaworld: SWA014World new.
	self addMorph: self swaworld.
	self swaworld
		game: self;
		center: self center;
		realCenter: self center;
		yourself.
	self swaworld image center: self center.
	
	
! !

!SWA014Game methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:42'!
isPaused

	^ isPaused.! !

!SWA014Game methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:42'!
isPaused: aBoolean

	isPaused := aBoolean.! !

!SWA014Game methodsFor: 'input events' stamp: 'TZ 2/2/2017 17:19'!
mouseEnter: anEvent

	anEvent hand newKeyboardFocus: self.! !

!SWA014Game methodsFor: 'input events' stamp: 'TZ 2/2/2017 17:19'!
mouseLeave: anEvent

	anEvent hand newKeyboardFocus: nil.! !

!SWA014Game methodsFor: 'world manipulation' stamp: 'TZ 2/2/2017 18:55'!
movePlayerBlobToCenter

	self swaworld realCenter: self swaworld realCenter + ((self swaworld blob calculateRealCenterFor: self center) - self swaworld blob realCenter).
	self swaworld refreshCenter.! !

!SWA014Game methodsFor: 'constants' stamp: 'Tc 2/3/2017 11:48'!
numberOfEnemies

	^ 50.! !

!SWA014Game methodsFor: 'spawning' stamp: 'TZ 2/2/2017 17:22'!
openHighscoreWindow
	|newHighscoreWindow|
	
	newHighscoreWindow := SWA014Highscore new. 
	
	self flag: 'Eig sollte es nicht mehr nötig sein die Welt zu übergeben'.
	newHighscoreWindow swaworld: self swaworld.
	self addMorph: newHighscoreWindow.! !

!SWA014Game methodsFor: 'game events' stamp: 'TZ 1/27/2017 17:00'!
pause

	self swaworld listOfLivingThings do: [:aLivingThing|
		aLivingThing
			saveSpeed;
			speed: 0].
	self isPaused: true.! !

!SWA014Game methodsFor: 'spawning' stamp: 'Tc 2/3/2017 11:32'!
randomEnemySize
	|maxSize|
	
	"In a quater of all cases we spawn a realy big (as big as the playerBlob) guy"
	maxSize := (SWA014Random isTrueIn: 1 outOf: 4) 
		ifTrue: [(self swaworld blob bodysize) asInteger]
		ifFalse: [self defaultMaxEnemySize].
	
	^ Random new nextInt: maxSize.
! !

!SWA014Game methodsFor: 'game events' stamp: 'Tc 2/3/2017 11:32'!
showEvolveOptions
	|evolveMenu|
	
	evolveMenu := SWA014EvolveMenu new.
	evolveMenu
		game: self;
		extent: self extent;
		center: self center;
		showOptions: self upgradesUnavailableToPlayerBlob copy;
		yourself.
		
	self addMorph: evolveMenu.! !

!SWA014Game methodsFor: 'spawning' stamp: 'Tc 2/3/2017 12:08'!
spawnEnemy
	|enemy random|
	
	random := Random new.
	enemy := SWA014Enemy new.
	
	"Im Gegensatz zum Spieler erhalten Enemies ihre Upgrades vom Game abhängig vom Level des Spielers und nicht durch Evolution."
	self flag: 'Vielleicht sollten die Enemies selbst Evolution betreiben.'.
	self giveUpgradesToEnemy: enemy.
	
	enemy
		realCenter: (random nextInt: self swaworld width)@(random nextInt: self swaworld height);
		bodysize: self randomEnemySize;
		swaworld: self swaworld;
		game: self;
		refreshCenter;
		yourself.
	
	self swaworld listOfEnemies add: enemy.
	self swaworld addMorph: enemy.! !

!SWA014Game methodsFor: 'spawning' stamp: 'Tc 2/3/2017 11:52'!
spawnInitialEnemies

	1 to: self numberOfEnemies do:[:x| self spawnEnemy ]. ! !

!SWA014Game methodsFor: 'spawning' stamp: 'Tc 2/3/2017 11:38'!
spawnPlayerBlob
	|newPlayerBlob|
	
	newPlayerBlob := SWA014PlayerBlob new.
	
	newPlayerBlob
		color: Color red;
		bodysize: 60;
		realCenter: self swaworld extent / 2;
		swaworld: self swaworld;
		game: self;
		refreshCenter;
		yourself.
	
	self swaworld
		blob: newPlayerBlob;
		addMorph: newPlayerBlob;
		yourself.! !

!SWA014Game methodsFor: 'spawning' stamp: 'Tc 2/3/2017 11:44'!
spawnUpgradeBar
	|aBar|
	
	aBar := SWA014UpgradeBar new position: self upgradeBarPosition.
	
	self
		addMorph: aBar;
		upgradeBar: aBar;
		yourself.
	! !

!SWA014Game methodsFor: 'override' stamp: 'TZ 1/27/2017 16:41'!
step

	"Make sure the PlayerBlob is in the center"
	self movePlayerBlobToCenter.
! !

!SWA014Game methodsFor: 'override' stamp: 'TZ 2/2/2017 17:20'!
stepTime

	^ 5000.! !

!SWA014Game methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:42'!
swaworld

	^ world.! !

!SWA014Game methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:42'!
swaworld: aWorld

	world := aWorld.! !

!SWA014Game methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:42'!
upgradeBar

	^ upgradeBar.! !

!SWA014Game methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:42'!
upgradeBar: aBar

	upgradeBar := aBar.! !

!SWA014Game methodsFor: 'constants' stamp: 'TZ 2/2/2017 18:46'!
upgradeBarPosition

	^ (self bounds right - 125)@(self bounds top + 50).! !

!SWA014Game methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:42'!
upgradeDictionary

	^ upgradeDictionary.! !

!SWA014Game methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:42'!
upgradeDictionary: aDictionary

	upgradeDictionary := aDictionary.! !

!SWA014Game methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:50'!
upgradesUnavailableToPlayerBlob

	^ upgradesUnavailableToPlayerBlob.! !

!SWA014Game methodsFor: 'accessing' stamp: 'TZ 1/27/2017 16:49'!
upgradesUnavailableToPlayerBlob: aList

	upgradesUnavailableToPlayerBlob := aList.! !

Morph subclass: #SWA014Menu
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Menu class methodsFor: 'as yet unclassified' stamp: 'MV 12/16/2016 11:32'!
open
	^SWA014Menu new openInWorld.! !

!SWA014Menu methodsFor: 'initialization' stamp: 'TZ 1/27/2017 16:16'!
initialize 
	super initialize.
	
	self
		extent: World extent;
		addMorph: (ImageMorph new image: (Form fromFileNamed: 'Background.jpg'));
		addMorph: (SWA014StartButton new center: (self width /2)@((12/25) * self height));
		addMorph: (SWA014EndButton new center: (self width /2)@((13/25) * self height));
		clipSubmorphs: true;
		yourself.! !

Morph subclass: #SWA014UpgradeBar
	instanceVariableNames: 'upgradeCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014UpgradeBar methodsFor: 'accessing' stamp: 'MV 1/20/2017 18:50'!
add: anUpgrade
	self addMorph: anUpgrade.
	anUpgrade center: (self center x)@(self position y + 50 + (self upgradeCount * 100)).
	anUpgrade extent: 75@75.
	self upgradeCount: self upgradeCount + 1.! !

!SWA014UpgradeBar methodsFor: 'initialization' stamp: 'MV 1/20/2017 18:16'!
initialize
	super initialize.
	self 
		extent: 50@500;
		color: Color transparent;
		upgradeCount: 0;
		yourself.! !

!SWA014UpgradeBar methodsFor: 'accessing' stamp: 'MV 1/20/2017 17:38'!
upgradeCount
	^ upgradeCount.! !

!SWA014UpgradeBar methodsFor: 'accessing' stamp: 'MV 1/20/2017 17:38'!
upgradeCount: aNumber
	upgradeCount := aNumber.! !

Morph subclass: #SWA014World
	instanceVariableNames: 'worldSize listOfEnemies listOfFood blob game realCenter image'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014World commentStamp: 'M.V. 11/11/2016 11:52' prior: 0!
Die Welt in der gespielt wird. Sie beinhaltet Feinde und hat eine gewisse Größe.!

!SWA014World methodsFor: 'world content' stamp: 'MV 1/13/2017 16:54'!
blob
	^blob.! !

!SWA014World methodsFor: 'world content' stamp: 'MV 1/13/2017 16:54'!
blob: aBlob
	blob := aBlob.! !

!SWA014World methodsFor: 'collisionHandling' stamp: 'Tc 1/27/2017 10:31'!
checkForBorderCollisions
	self listOfLivingThings do: [:enemy | 
		self checkOnRightSide: enemy.
		self checkOnLeftSide: enemy.
		self checkOnTopSide: enemy.
		self checkOnBottomSide: enemy].! !

!SWA014World methodsFor: 'collisionHandling' stamp: 'TZ 2/2/2017 20:32'!
checkOnBottomSide: anEnemy
	anEnemy bounds bottom > self bounds bottom ifTrue: [
			anEnemy isPlayerBlob ifTrue: [
				self realCenter: (self realCenter x)@(anEnemy bounds bottom - self radius).
				self refreshCenter]. 
			anEnemy realCenter: (anEnemy realCenter x)@(self worldSize - anEnemy radius).
			anEnemy refreshCenter]! !

!SWA014World methodsFor: 'collisionHandling' stamp: 'TZ 2/2/2017 20:32'!
checkOnLeftSide: anEnemy
	anEnemy bounds left < self bounds left ifTrue: [
			anEnemy isPlayerBlob ifTrue: [
				self realCenter: (anEnemy bounds left + self radius)@(self realCenter y).
				self refreshCenter]. 
			anEnemy realCenter: (anEnemy radius)@(anEnemy realCenter y).
			anEnemy refreshCenter].! !

!SWA014World methodsFor: 'collisionHandling' stamp: 'TZ 2/2/2017 20:32'!
checkOnRightSide: anEnemy
	anEnemy bounds right > self bounds right ifTrue:	[
			anEnemy isPlayerBlob ifTrue: [
				self realCenter: (anEnemy bounds right - self radius)@(self realCenter y).
				self refreshCenter]. 
			anEnemy realCenter: (self worldSize - anEnemy radius)@(anEnemy realCenter y).
			anEnemy refreshCenter].! !

!SWA014World methodsFor: 'collisionHandling' stamp: 'TZ 2/2/2017 20:32'!
checkOnTopSide: anEnemy
	anEnemy bounds top < self bounds top ifTrue: [
			anEnemy isPlayerBlob ifTrue: [
				self realCenter: (self realCenter x)@(anEnemy bounds top + self radius).
				self refreshCenter]. 
			anEnemy realCenter: (anEnemy realCenter x)@(anEnemy radius).
			anEnemy refreshCenter].! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 21:48'!
game
	^game.! !

!SWA014World methodsFor: 'accessing' stamp: 'M.V. 11/24/2016 21:48'!
game: x
	game := x.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 1/12/2017 19:29'!
image
	^ image.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 1/12/2017 19:29'!
image: anImage
	image := anImage.! !

!SWA014World methodsFor: 'initialization' stamp: 'TZ 1/27/2017 16:09'!
initialize
	super initialize.
		
	self 
		image: (ImageMorph new image: (Form fromFileNamed: 'Background.jpg'));"Be sure, that the picture is in the resource folder with that name"
		addMorph: self image;
		listOfEnemies: Set new;
		listOfFood: Set new;
		blob: nil;
		worldSize: 3000;
		extent: self worldSize asPoint;	
		center: 0 asPoint;
		realCenter: 0.0 asPoint;
		yourself.
		! !

!SWA014World methodsFor: 'world content' stamp: 'L.K. 1/13/2017 14:52'!
listOfEnemies
	^ listOfEnemies.! !

!SWA014World methodsFor: 'world content' stamp: 'L.K. 1/13/2017 14:53'!
listOfEnemies: aList
	listOfEnemies := aList.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 12/9/2016 11:39'!
listOfFood
	^ listOfFood.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 1/2/2017 22:57'!
listOfFood: aList
	listOfFood := aList.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 1/12/2017 21:15'!
listOfLivingThings
	|listOfLivingThings|
	listOfLivingThings := self listOfEnemies copy.
	listOfLivingThings add: self blob.
	^listOfLivingThings.! !

!SWA014World methodsFor: 'body transformation' stamp: 'Tc 1/13/2017 14:34'!
radius
	^worldSize / 2.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 12/16/2016 16:27'!
realCenter
	^realCenter.! !

!SWA014World methodsFor: 'accessing' stamp: 'MV 12/16/2016 16:27'!
realCenter: aPoint
	realCenter := aPoint.! !

!SWA014World methodsFor: 'movement' stamp: 'MV 1/7/2017 15:57'!
refreshCenter
	self center: self realCenter.! !

!SWA014World methodsFor: 'overrideMethod' stamp: 'MV 12/22/2016 11:00'!
step
	self 
		checkForBorderCollisions;
		"refreshCenter;"
		yourself.! !

!SWA014World methodsFor: 'overrideMethod' stamp: 'L.K. 1/13/2017 14:52'!
stepTime
	^100.! !

!SWA014World methodsFor: 'body transformation' stamp: 'L.K. 1/13/2017 14:53'!
worldSize
	^worldSize.! !

!SWA014World methodsFor: 'body transformation' stamp: 'L.K. 1/13/2017 14:53'!
worldSize: anObject
	worldSize := anObject.! !

ImageMorph subclass: #SWA014Upgrade
	instanceVariableNames: 'upgradeOwner coolDownMorph cooling cooldown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Upgrade commentStamp: 'MV 1/21/2017 14:48' prior: 0!
To add a new Upgrade change: Game->initializeDictionary, Game->handleKeystroke, and right now Game->showEvolveOptions. !

SWA014Upgrade subclass: #SWA014DrainUpgrade
	instanceVariableNames: 'drainTarget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014DrainUpgrade methodsFor: 'starting up' stamp: 'TZ 2/2/2017 20:57'!
activateUpgrade

	self drainTarget: self upgradeOwner nearestLivingThing.
	self drainTarget borderColor: Color lavender.
	self startStepping.
	self futureDo: #stopStepping at: self drainDuration args: #().
	self drainTarget futureDo: #borderColor: at: 4000 args: (Array with: Color black).! !

!SWA014DrainUpgrade methodsFor: 'constants' stamp: 'TZ 2/2/2017 20:53'!
amountOfDrain

	^ 3.! !

!SWA014DrainUpgrade methodsFor: 'constants' stamp: 'TZ 2/2/2017 20:56'!
drainDuration

	^ 4000.! !

!SWA014DrainUpgrade methodsFor: 'accessing' stamp: 'TZ 2/2/2017 20:51'!
drainTarget

	^ drainTarget.! !

!SWA014DrainUpgrade methodsFor: 'accessing' stamp: 'TZ 2/2/2017 20:51'!
drainTarget: aLivingThing

	drainTarget := aLivingThing.! !

!SWA014DrainUpgrade methodsFor: 'initialization' stamp: 'TZ 2/2/2017 20:51'!
initialize
	super initialize.
	
	self 
		image: (Form fromFileNamed: 'DrainUpgrade.png');
		stopStepping;
		yourself.! !

!SWA014DrainUpgrade methodsFor: 'override' stamp: 'TZ 2/2/2017 20:54'!
step

	self drainTarget = nil ifFalse: [
		self drainTarget bodysize: (self drainTarget bodysize - self amountOfDrain).
		self upgradeOwner bodysize: (self upgradeOwner bodysize - self amountOfDrain)].! !

!SWA014DrainUpgrade methodsFor: 'override' stamp: 'TZ 2/2/2017 20:55'!
stepTime

	^ 400.
	! !

SWA014Upgrade subclass: #SWA014NullUpgrade
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014NullUpgrade methodsFor: 'starting up' stamp: 'TZ 2/2/2017 20:57'!
activateUpgrade
	"This class should do nothing"! !

SWA014Upgrade subclass: #SWA014ShockwaveUpgrade
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014ShockwaveUpgrade methodsFor: 'starting up' stamp: 'TZ 2/2/2017 21:07'!
activateUpgrade
	|nearLivingThings|
	
	nearLivingThings := self upgradeOwner swaworld listOfLivingThings select: [:livingThing|
		(self upgradeOwner squaredDistanceTo: livingThing realCenter) < (self upgradeOwner radius + self shockRadius) squared]. 
	
	nearLivingThings remove: self upgradeOwner.
	
	nearLivingThings do: [:livingThing|
		livingThing
			realCenter: livingThing realCenter + (self shockRadius * (self upgradeOwner vectorToPoint: livingThing realCenter));
			refreshCenter;
			yourself].! !

!SWA014ShockwaveUpgrade methodsFor: 'constants' stamp: 'TZ 2/2/2017 21:04'!
shockRadius
	
	^ 200.! !

SWA014Upgrade subclass: #SWA014SpeedboostUpgrade
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014SpeedboostUpgrade methodsFor: 'starting up' stamp: 'TZ 2/2/2017 21:12'!
activateUpgrade

	self upgradeOwner 
		speed: self upgradeOwner speed + self speedIncreasement;
		futureDo: #speed: at: self speedboostDuration args: (Array with: (self upgradeOwner speed - self speedIncreasement));
		yourself.! !

!SWA014SpeedboostUpgrade methodsFor: 'initialization' stamp: 'MV 1/20/2017 19:32'!
initialize
	super initialize.
	self image: (Form fromFileNamed: 'SpeedBoostUpgrade.png').! !

!SWA014SpeedboostUpgrade methodsFor: 'constants' stamp: 'TZ 2/2/2017 21:10'!
speedIncreasement
	
	^ 11.! !

!SWA014SpeedboostUpgrade methodsFor: 'constants' stamp: 'TZ 2/2/2017 21:09'!
speedboostDuration

	^ 1000.! !

SWA014Upgrade subclass: #SWA014TrapUpgrade
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014TrapUpgrade methodsFor: 'starting up' stamp: 'TZ 2/2/2017 21:12'!
activateUpgrade

 	self spawnTrap.
			! !

!SWA014TrapUpgrade methodsFor: 'initialization' stamp: 'TZ 2/2/2017 21:12'!
initialize
	super initialize.
	
	self image: (Form fromFileNamed: 'TrapUpgrade.png').! !

!SWA014TrapUpgrade methodsFor: 'world manipulation' stamp: 'TZ 2/2/2017 21:13'!
spawnTrap
	|aTrap|
	
	aTrap := SWA014Trap new.
	
	aTrap
		swaworld: self upgradeOwner swaworld;
		center: self upgradeOwner center - (self upgradeOwner direction * self upgradeOwner bodysize);
		yourself.
	
	self upgradeOwner swaworld addMorph: aTrap.
! !

!SWA014Upgrade methodsFor: 'starting up' stamp: 'TZ 2/2/2017 20:49'!
activateIfNotCooling

	self cooling ifFalse: [
		self
			activateUpgrade;
			cooling: true;
			futureDo: #cooling: at: (self cooldown) args: (Array with: false);
			yourself].
	
	self coolDownMorph
		show;
		futureDo: #hide at: self cooldown args: #();
		yourself.! !

!SWA014Upgrade methodsFor: 'starting up' stamp: 'TZ 2/2/2017 20:50'!
activateUpgrade
	"The different Upgrades should overwrite this. This method gets called, when the player wants to use an Upgrade."
	"To add a new Upgrade change: Game->initializeDictionary, Game->handleKeystroke, and right now Game->showEvolveOptions."
	
	self SubclassResponsibility.
	! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'TZ 2/2/2017 20:46'!
coolDownMorph

	^ coolDownMorph.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'TZ 2/2/2017 20:46'!
coolDownMorph: aMorph

	coolDownMorph := aMorph.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'TZ 2/2/2017 20:46'!
cooldown

	^ cooldown.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'TZ 2/2/2017 20:46'!
cooldown: aTime

	cooldown := aTime.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'TZ 2/2/2017 20:46'!
cooling

	^ cooling.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'TZ 2/2/2017 20:46'!
cooling: aBoolean

	cooling := aBoolean.! !

!SWA014Upgrade methodsFor: 'initialization' stamp: 'TZ 2/2/2017 20:48'!
initialize
	super initialize.
	
	self
		coolDownMorph: ImageMorph new; 
		cooling: false;
		cooldown: 10000;
		addMorph: self coolDownMorph;
		yourself.
		
	self coolDownMorph
		image: (Form fromFileNamed: 'Cooldown.png');
		hide;
		yourself.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'TZ 2/2/2017 20:46'!
upgradeOwner

	^ upgradeOwner.! !

!SWA014Upgrade methodsFor: 'accessing' stamp: 'TZ 2/2/2017 20:46'!
upgradeOwner: aLivingThing

	upgradeOwner := aLivingThing.! !

SimpleButtonMorph subclass: #SWA014ChooseButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014ChooseButton methodsFor: 'initialization' stamp: 'Tc 2/3/2017 11:25'!
initialize 
	super initialize.

	self 
		label: 'Choose!!';
		color: Color red;
		yourself.! !

!SWA014ChooseButton methodsFor: 'event handling' stamp: 'TZ 1/27/2017 16:31'!
mouseDown: anEvent

	"The owner is always an EvolveOption"
	self owner getChosen.! !

SimpleButtonMorph subclass: #SWA014EndButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014EndButton methodsFor: 'initialization' stamp: 'Tc 2/3/2017 11:25'!
initialize 
	super initialize.

	self 
		label: 'End Game';
		color: Color red;
		yourself.! !

!SWA014EndButton methodsFor: 'event handling' stamp: 'TZ 1/27/2017 16:31'!
mouseDown: anEvent

	"The owner is the menu, this button closes it"
	self owner delete.! !

SimpleButtonMorph subclass: #SWA014StartButton
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014StartButton methodsFor: 'initialization' stamp: 'TZ 1/27/2017 16:19'!
initialize 
	super initialize.

	self 
		label: 'Start Game';
		color: Color green;
		yourself.! !

!SWA014StartButton methodsFor: 'event handling' stamp: 'TZ 2/2/2017 20:34'!
mouseDown: anEvent

	SWA014Game new.! !

StringMorph subclass: #SWA014Highscore
	instanceVariableNames: 'value world'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SWA014'!

!SWA014Highscore methodsFor: 'accessing' stamp: 'TZ 2/2/2017 18:58'!
highscoreValue

	^ value.! !

!SWA014Highscore methodsFor: 'accessing' stamp: 'TZ 2/2/2017 18:58'!
highscoreValue: aValue

	value := aValue.! !

!SWA014Highscore methodsFor: 'initialization' stamp: 'Tc 1/13/2017 15:33'!
initialize 
	super initialize.
	
	self
		highscoreValue: 0;
		acceptValue: 0;
		color: Color red;
		width: 500;
		height: 500;
		yourself.! !

!SWA014Highscore methodsFor: 'updating' stamp: 'TZ 2/2/2017 19:14'!
setNewHighscore
	|highscoreValueAsString|
	
	((self highscoreValue + 60) < self swaworld blob bodysize) ifTrue: [self highscoreValue:  (self swaworld blob bodysize - 60) asInteger].
	highscoreValueAsString := self highscoreValue asString.
	self fontName: 'BitstreamVeraSans' size: 60.
	! !

!SWA014Highscore methodsFor: 'stepping' stamp: 'Tc 1/13/2017 15:42'!
step
	self setNewHighscore.
	self acceptValue: value.! !

!SWA014Highscore methodsFor: 'stepping' stamp: 'Tc 1/13/2017 11:58'!
stepTime
	^1.! !

!SWA014Highscore methodsFor: 'accessing' stamp: 'Tc 1/13/2017 14:54'!
swaworld
	^world
! !

!SWA014Highscore methodsFor: 'accessing' stamp: 'Tc 1/13/2017 14:55'!
swaworld: aWorld
	world := aWorld! !
